#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=..\icons\ico\rndmp3cpy.ico
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

#cs
-----------------------------------------------------------------
RndMp3Copy
Licensed under the Creative Commons GNU General Public License
http://creativecommons.org/licenses/GPL/2.0/
Author: Adrian Holfter <aholfter@googlemail.com>
-----------------------------------------------------------------
#ce

#include <ButtonConstants.au3>
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>

$Form1_1 = GUICreate("RndMp3Copy Gui", 400, 465);

GuiSetState(@SW_HIDE)

$Label1 = GUICtrlCreateLabel("Music Directory", 10, 10, 100, 21, $ES_RIGHT)
GUICtrlSetFont(-1, 10) ;, 400, "MS Sans Serif"
$InputSource = GUICtrlCreateInput(@WorkingDir, 120, 10, 185, 21)
$ButtonSource = GUICtrlCreateButton("Search...", 310, 10, 80, 21, $WS_GROUP)

$Label2 = GUICtrlCreateLabel("Target Directory", 10, 41, 100, 21, $ES_RIGHT)
GUICtrlSetFont(-1, 10)
$InputTarget = GUICtrlCreateInput(@WorkingDir, 120, 41, 185, 21)
$ButtonTarget = GUICtrlCreateButton("Search...", 310, 41, 80, 21, $WS_GROUP)

$Label3 = GUICtrlCreateLabel("Copy", 70, 72, 40, 21, $ES_RIGHT)
GUICtrlSetFont(-1, 10)
$InputSize = GUICtrlCreateInput("20", 120, 72, 90, 21)
$UpDown = GUICtrlCreateUpdown($InputSize);
GUICtrlSetLimit($InputSize, 10240, 0)
$Label4 = GUICtrlCreateLabel("MB Music", 220, 72, 60, 21)
GUICtrlSetFont(-1, 10)
$ChkFill = GuiCtrlCreateCheckbox("Fill device", 310, 72, 80, 21)

GUICtrlCreateGroup("Name Format", 10, 103, 185, 134);
$RadioFormat0 = GUICtrlCreateRadio("Song.mp3", 20, 123, 165, 21)
GUICtrlSetState(-1, $GUI_CHECKED)
$RadioFormat1 = GUICtrlCreateRadio("Folder\Subfolder\Song.mp3", 20, 159, 165, 21)
$RadioFormat2 = GUICtrlCreateRadio("Folder-Subfolder-Song.mp3", 20, 195, 165, 21)

GuiCtrlCreateGroup("File Types", 205, 103, 185, 134);
$ChkMp3 = GUICtrlCreateCheckbox("mp3", 220, 123, 165, 21)
GUICtrlSetState(-1, $GUI_CHECKED)
$ChkWma = GUICtrlCreateCheckbox("wma", 220, 144, 165, 21)
$ChkOgg = GUICtrlCreateCheckbox("ogg", 220, 165, 165, 21)
$ChkAac = GUICtrlCreateCheckbox("aac", 220, 186, 165, 21)
$ChkFlac = GUICtrlCreateCheckbox("flac", 220, 207, 165, 21)

GuiCtrlCreateGroup("Regular Expressions", 10, 248, 380, 80);
$ChkInExp = GUICtrlCreateCheckbox("Must match", 20, 268, 80, 21)
$InputInExp = GUICtrlCreateInput("(Offspring|Rise.?Against)", 120, 268, 260, 21)
$ChkExExp = GUICtrlCreateCheckbox("Don't match", 20, 299, 80, 21)
$InputExExp = GUICtrlCreateInput("(Tokio.?Hotel)", 120, 299, 260, 21)

GuiCtrlCreateGroup("Miscellaneous", 10, 339, 380, 80);
$ChkUsedList = GUICtrlCreateCheckbox("Used-List", 20, 359, 100, 21)
$InputUsedList = GUICtrlCreateInput(@WorkingDir, 120, 359, 185, 21)
$ButtonUsedList = GUICtrlCreateButton("Search...", 310, 359, 70, 21, $WS_GROUP)

$ChkMove = GUICtrlCreateCheckbox("Move files instead of copying", 20, 390, 360, 21)

GuiCtrlCreateLabel("by ADI64", 5, 445, 100, 16);
$ButtonGo = GUICtrlCreateButton("Let's Go!", 120, 430, 270, 25, $WS_GROUP)

$InputDir = "";
$OutputDir = "";
$Size = 0;
$filter = "";
$ChkInExpToggle = 0;
$ChkExExpToggle = 0;
$ChkUsedListToggle = 0;
$ChkFillToggle = 0;
GuiCtrlSetState($InputInExp, $GUI_DISABLE);
GuiCtrlSetState($InputExExp, $GUI_DISABLE);
GuiCtrlSetState($InputUsedList, $GUI_DISABLE);
$Binary = @WorkingDir & "\RndMp3Copy.exe";
If(Not FileExists($Binary)) Then
	MsgBox(0, "", $Binary & " does not exist!" &@CRLF& "You need to have RndMp3Copy.exe!");
	Exit 0;
EndIf

GUISetState(@SW_SHOW)

Do
	$msg = GUIGetMsg();
	If $msg == $ButtonGo Then
		_launch();
	ElseIf $msg == $ButtonSource Then
		_selectFile(1, $InputSource);
	ElseIf $msg == $ButtonTarget Then
		_selectFile(1, $InputTarget);
	ElseIf $msg == $ButtonUsedList Then
		_selectFile(0, $InputUsedList);
	ElseIf $msg == $ChkFill Then
		If $ChkFillToggle == 0 Then
			GuiCtrlSetState($InputSize, $GUI_DISABLE);
			GuiCtrlSetState($UpDown, $GUI_DISABLE);
			$ChkFillToggle = 1;
		Else
			GuiCtrlSetState($InputSize, $GUI_ENABLE);
			GuiCtrlSetState($UpDown, $GUI_ENABLE);
			$ChkFillToggle = 0;
		EndIf
	ElseIf $msg == $ChkInExp Then
		If $ChkInExpToggle == 1 Then
			GuiCtrlSetState($InputInExp, $GUI_DISABLE);
			$ChkInExpToggle = 0;
		Else
			GuiCtrlSetState($InputInExp, $GUI_ENABLE);
			$ChkInExpToggle = 1;
		EndIf
	ElseIf $msg == $ChkExExp Then
		If $ChkExExpToggle == 1 Then
			GuiCtrlSetState($InputExExp, $GUI_DISABLE);
			$ChkExExpToggle = 0;
		Else
			GuiCtrlSetState($InputExExp, $GUI_ENABLE);
			$ChkExExpToggle = 1;
		EndIf
	ElseIf $msg == $ChkUsedList Then
		If $ChkUsedListToggle == 1 Then
			GuiCtrlSetState($InputUsedList, $GUI_DISABLE);
			$ChkUsedListToggle = 0;
		Else
			GuiCtrlSetState($InputUsedList, $GUI_ENABLE);
			$ChkUsedListToggle = 1;
		EndIf
	EndIf

	If GuiCtrlRead($InputSize) > 10240 Then
		GuiCtrlSetData($InputSize, 10240);
	ElseIf GuiCtrlRead($InputSize) < 0 Then
		GuiCtrlSetData($InputSize, 0);
	EndIf

Until $msg == $GUI_EVENT_CLOSE

Func _launch()
	$InputDir = GuiCtrlRead($InputSource);
	$OutputDir = GuiCtrlRead($InputTarget);

	If $ChkFillToggle == 0 Then
		$Size = GUICtrlRead($InputSize);
	Else
		$Size = "all";
	EndIf

	If Not FileExists($Binary) Then
		MsgBox(0, "Error", "RndMp3Copy.exe does not exist!");
		Return;
	EndIf

	If Not FileExists($InputDir) Then
		MsgBox(0, "Error", "Music Directory does not exist!");
		Return;
	EndIf
	; Kill end slash
	If StringRight($InputDir, 1) == "\" Then
		$InputDir = StringLeft($InputDir, StringLen($InputDir) - 1);
	EndIf

	If Not FileExists($OutputDir) Then
		MsgBox(0, "Error", "Target Directory does not exist!");
		Return;
	EndIf
	; Kill end slash
	If StringRight($OutputDir, 1) == "\" Then
		$OutputDir = StringLeft($OutputDir, StringLen($OutputDir) - 1);
	EndIf


	$filter = "";
	If GuiCtrlRead($ChkMp3) == $GUI_CHECKED Then $filter &= "mp3,";
	If GuiCtrlRead($ChkWma) == $GUI_CHECKED Then $filter &= "wma,";
	If GuiCtrlRead($ChkOgg) == $GUI_CHECKED Then $filter &= "ogg,";
	If GuiCtrlRead($ChkAac) == $GUI_CHECKED Then $filter &= "aac,";
	If GuiCtrlRead($ChkFlac) == $GUI_CHECKED Then $filter &= "flac,";

	$mode = 0;
	If GuiCtrlRead($RadioFormat0) == $GUI_CHECKED Then
		$mode = 0;
	ElseIf GuiCtrlRead($RadioFormat1) == $GUI_CHECKED Then
		$mode = 1;
	ElseIf GuiCtrlRead($RadioFormat2) == $GUI_CHECKED Then
		$mode = 2;
	EndIf

	$args = @ComSpec & ' /c ' & '@echo off && "' & $Binary & '" -i "' & $InputDir & '" -o "' & $OutputDir & '" -s ' & $Size & ' -d ' & $mode & ' -w';

	If StringLen($filter) > 1 Then
		$filter = StringMid($filter, 1, StringLen($filter) -1);
		$args &= ' -f "' & $filter & '"';
	EndIf

	If (GuiCtrlRead($ChkInExp) == $GUI_CHECKED) And (GuiCtrlRead($InputInExp) <> "") Then
		$args &= ' -in "' & GuiCtrlRead($InputInExp) & '"';
	EndIf
	If (GuiCtrlRead($ChkExExp) == $GUI_CHECKED) And (GuiCtrlRead($InputExExp) <> "") Then
		$args &= ' -ex "' & GuiCtrlRead($InputExExp) & '"';
	EndIf

	If (GuiCtrlRead($ChkUsedList) == $GUI_CHECKED) And (GuiCtrlRead($InputUsedList) <> "") Then
		$args &= ' -l "' & GuiCtrlRead($InputUsedList) & '"';
	EndIf
	
	If (GUICtrlRead($ChkMove) == $GUI_CHECKED) Then
		$args &= ' -m';
	EndIf

	MsgBox(0, "Please Check Command Line", $args);

	RunWait($args);

EndFunc

Func _selectFile($mode, $output)
	If $mode == 1 Then
		$selected = FileSelectFolder("Choose a folder.", "");
	Else
		$selected = FileSaveDialog ("Choose or create UsedList", @WorkingDir, "All (*.*)");
	EndIf

	If @error Or $selected == "" Then
		Return;
	EndIf

	GuiCtrlSetData($output, $selected);
#cs
	If $var == 0 Then
		GuiCtrlSetData($InputSource, $selected);
	ElseIf $var == 1 Then
		GuiCtrlSetData($InputTarget, $selected);
	Else
		MsgBox(0, "Error", "You screwed the program.");
		Return
	EndIf
#ce
EndFunc
